 

//We include the DS3231 library for the real time module
#include <DS3231.h>   
DS3231  rtc(SDA, SCL);          


//Define the I/O
#define MAX7219_Clock 13         //CLK pin for the MAX7219
#define MAX7219_Chip_Select 10   //CS pin for the MAX7219
#define MAX7219_Data_IN 12       //D_in pin for the MAX7219
     
int LED = 8;                    //Pin for the two blinking LEDs



//Other variables for the code
bool date_time = false;
int Delay=1000;                       //Variable used for the 1 second loop. Each 1s we change the LED state so it will blink    
bool LED_state = false;               //Here we save the LED state each loop, HIGH or LOW
unsigned long previousMillis = 0;     //Variable used to count the 1s loop time

String time_str = "";                 //Here we save the time in a string format from the real time module
String date_str = "";                 //Here we save the date in a string format from the rtc module
String prev_time_str = "";            //We save the last time value so we could compare it
String prev_date_str = "";            //We save the last date value so we could compare it
String hr_1_str = "";                 //We divide the hours and minutes in separate variables first digit for hour
String hr_2_str = "";                 //We divide the hours and minutes in separate variables second digit of hour
String min_1_str = "";                //We divide the hours and minutes in separate variables first digit of minute
String min_2_str = "";                //We divide the hours and minutes in separate variables secodn digit of minute
String sec_1_str = "";                //We divide the hours and minutes in separate variables first digit of seccond
String sec_2_str = "";                //We divide the hours and minutes in separate variables secodn digit of second
String yr_1_str = "";                 //We divide the years,months and day in separate variables first digit for year
String yr_2_str = "";                 //We divide the years,months and day in separate variables Second digit for year
String mon_1_str = "";                //We divide the years,months and day in separate variables first digit for month
String mon_2_str = "";                //We divide the years,months and day in separate variables Second digit for month
String day_1_str = "";                //We divide the years,months and day in separate variables first digit for year
String day_2_str = "";                //We divide the years,months and day in separate variables first digit for year


int hr_1 = 0;                         //first digit for hour
int hr_2 = 0;                         //second digit for hour
int min_1 = 0;                        //first digit for minute
int min_2 = 0;                        //second digit for minute
int sec_1 = 0;                        //first digit for second
int sec_2 = 0;                        //second digit for second
int yr_1 = 0;                         //first digit for year
int yr_2 = 0;                         //second digit for year
int mon_1 = 0;                        //first digit for month
int mon_2 = 0;                        //second digit for month
int day_1 = 0;                        //first digit for day
int day_2 = 0;                        //second digit for day

int set_hour = 0;
int set_minute = 0;
int set_year=19;
int set_month=1;
int set_day=1;




//This function will shift the data to the MAX7219 driver. 
void shift(byte send_to_address, byte send_this_data)
{
  digitalWrite(MAX7219_Chip_Select, LOW);
  shiftOut(MAX7219_Data_IN, MAX7219_Clock, MSBFIRST, send_to_address);
  shiftOut(MAX7219_Data_IN, MAX7219_Clock, MSBFIRST, send_this_data);
  digitalWrite(MAX7219_Chip_Select, HIGH);
}


 
void setup() {
  //Serial.begin(9600);
  rtc.begin();                                  //We start the real time module
  pinMode(MAX7219_Data_IN, OUTPUT);             //Define the data pin for the MAX7219 as output
  pinMode(MAX7219_Chip_Select, OUTPUT);         //Define the cs pin for the MAX7219 as output
  pinMode(MAX7219_Clock, OUTPUT);               //Define the clock pin for the MAX7219 as output
  digitalWrite(MAX7219_Chip_Select, HIGH);      //We set the CS to high, CS is negative enabeled

  pinMode(LED,OUTPUT);                            
  pinMode(A0,INPUT);                            //select clock/calender mode
  pinMode(A1,INPUT);                            // set hour/date
  pinMode(A2,INPUT);                            // set minute/month
  pinMode(A3,INPUT);                            //set year  
  
  //digitalWrite(SET, HIGH);                    //Not used any more
  digitalWrite(A0, HIGH);
  digitalWrite(A1, HIGH); 
  digitalWrite(A2, HIGH);  
  digitalWrite(A3, HIGH);

   delay(1000); //Small delay
  
}

void loop() {
   //This loop will execute each Delay=1000ms, so 1 second
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis >= Delay)
  {
    previousMillis += Delay; 
  if(!date_time)
  {    
    time_str = rtc.getTimeStr();      //First,we get the real time, hour, minute, second
    hr_1_str += (char)time_str[0];    //We separate the first digit hour value
    hr_1 = hr_1_str.toInt();          //Pass the hour value from String to int format
    hr_2_str += (char)time_str[1];    //We separate the second digit hour value
    hr_2 = hr_2_str.toInt();          //Pass the hour value from String to int format
    min_1_str += (char)time_str[3];   //We separate the first digit minute value 
    min_1 = min_1_str.toInt();        //Pass the minute value from String to int format
    min_2_str += (char)time_str[4];   //We separate the second digit minute value 
    min_2 = min_2_str.toInt();        //Pass the minute value from String to int format

    sec_1_str += (char)time_str[6];   //We separate the first digit second value 
    sec_1 = sec_1_str.toInt();        //Pass the second value from String to int format
    sec_2_str += (char)time_str[7];   //We separate the second digit second value 
    sec_2 = sec_2_str.toInt();        //Pass the second value from String to int format
    LED_state = !LED_state;           //Invert the blinking LED state each loop, so each 1 second.

    if(prev_time_str != time_str)     //If the time is not the same, we print the new value to the 7-seg display
    {
      print_time_to_7_seg(time_str);
    }
    prev_time_str = time_str;         //Save the last time value
  }
  if(date_time)
  {
        date_str = rtc.getDateStr(FORMAT_SHORT,FORMAT_LITTLEENDIAN);      //First,we get the real date, month,year, second
        yr_1_str += (char)date_str[6];    //We separate the first digit hour value
        yr_1 = yr_1_str.toInt();          //Pass the hour value from String to int format
        yr_2_str += (char)date_str[7];    //We separate the second digit hour value
        yr_2 = yr_2_str.toInt();          //Pass the hour value from String to int format
        mon_1_str += (char)date_str[3];   //We separate the first digit minute value 
        mon_1 = mon_1_str.toInt();        //Pass the minute value from String to int format
        mon_2_str += (char)date_str[4];   //We separate the second digit minute value 
        mon_2 = mon_2_str.toInt();        //Pass the minute value from String to int format

        day_1_str += (char)date_str[0];   //We separate the first digit second value 
        day_1 = day_1_str.toInt();        //Pass the second value from String to int format
        day_2_str += (char)date_str[1];   //We separate the second digit second value 
        day_2 = day_2_str.toInt();        //Pass the second value from String to int format
        LED_state = true;           //Invert the blinking LED state each loop, so each 1 second.

        if(prev_date_str != date_str)     //If the time is not the same, we print the new value to the 7-seg display
        {
          print_date_to_7_seg(date_str);
        }
        prev_date_str = date_str;         //Save the last time value

  }
   
   
   }//end of timer

    if (LED_state ){
      shift(0x03, 0x01); //Turn on hyphen
      shift(0x06, 0x01);
    } 
    if (!LED_state ){
      shift(0x03, 0x00); //Turn off hyphen
      shift(0x06, 0x00);
    }

if(!date_time)
{
    hr_1_str = "";                    //Reset the digits String valuew for hours and minutes
    hr_2_str = "";
    min_1_str = "";
    min_2_str = "";
    sec_1_str = "";
    sec_2_str = "";

    

   if(!digitalRead(A1))             //If the hour button is pressed, we increase hour by one
   {
     set_hour = hr_1*10+hr_2;         //get total hour value in int format 
     set_minute = min_1*10+min_2;     //get total minuter value in int forma
     set_hour = set_hour + 1;         //Increase hour by 1
     if(set_hour == 24)               //If we get to hour 24, we start from 0
     {
       set_hour = 0;
     }
     rtc.setTime(set_hour, set_minute, 30);     // Write the new time to the RTC module
     delay(50);
     time_str = rtc.getTimeStr(); 
     print_time_to_7_seg(time_str);            //Print the new time value to the 7-seg dispaly
   }

    //We do the same for the minute push button
   if(!digitalRead(A2))
   {
     set_hour = hr_1*10+hr_2;
     set_minute = min_1*10+min_2;
     set_minute = set_minute + 1;
     if(set_minute == 60)
     {
       set_minute = 0;
     }
     rtc.setTime(set_hour, set_minute, 30);     // Set the time to 12:00:00 (24hr format)
     delay(50);
     time_str = rtc.getTimeStr(); 
     print_time_to_7_seg(time_str);
   }
}
if(date_time)
{
    yr_1_str = "";                    //Reset the digits String valuew for hours and minutes
    yr_2_str = "";
    mon_1_str = "";
    mon_2_str = "";
    day_1_str = "";
    day_2_str = "";

    

   if(!digitalRead(A1))             //If the day button is pressed, we increase day by one
   {
     set_day = day_1*10+day_2;         //get total day value in int format 
     set_month = mon_1*10+mon_2;     //get total month value in int forma
     set_year = yr_1*10+yr_2+2000;     //get year value in int forma
     set_day = set_day + 1;         //Increase day by 1
     if(set_day >= 32)               //If we get to date 31, we start from 0
     {
       set_day = 1;
     }
     rtc.setDate(set_day, set_month, set_year);     // Write the new date to the RTC module
     delay(50);
     date_str = rtc.getDateStr(FORMAT_SHORT,FORMAT_LITTLEENDIAN); 
     print_date_to_7_seg(date_str);            //Print the new date value to the 7-seg dispaly
   }

    //We do the same for the month push button
   if(!digitalRead(A2))
   {
     set_day = day_1*10+day_2;         //get total day value in int format 
     set_month = mon_1*10+mon_2;     //get month value in int forma
     set_year = yr_1*10+yr_2+2000;     //get year value in int forma
     set_month = set_month + 1;
     if(set_month >= 13)
     {
       set_month = 1;
     }
     rtc.setDate(set_day, set_month, set_year);     // Write the new date to the RTC module
     delay(50);
     date_str = rtc.getDateStr(FORMAT_SHORT,FORMAT_LITTLEENDIAN); 
     print_date_to_7_seg(date_str);
   } 

    //We do the same for the year push button
   if(!digitalRead(A3))
   {
     set_day = day_1*10+day_2;         //get total day value in int format 
     set_month = mon_1*10+mon_2;     //get total month value in int forma
     set_year = yr_1*10+yr_2;     //get total year value in int forma
     set_year = set_year + 1;
     if(set_year >= 25)
     {
       set_year = 19;
     }
     set_year = set_year + 2000;
     rtc.setDate(set_day, set_month, set_year);     // Write the new date to the RTC module
     delay(50);  
     date_str = rtc.getDateStr(FORMAT_SHORT,FORMAT_LITTLEENDIAN);
     print_date_to_7_seg(date_str);
   } 

   
}

    //calendermode/time mode selection
   if(!digitalRead(A0))
   {
    delay(50); 
    date_time=!date_time;
    } 

    
}//end of void loop

//This function will shift the time to the MAX7219 driver
void print_time_to_7_seg(String the_time)
{

  if(hr_1 == 0)
  {
    shift(0x08, 0); 
  }
  if(hr_1 == 1)
  {
    shift(0x08, 1); 
  }
  if(hr_1 == 2)
  {
    shift(0x08, 2); 
  }
  if(hr_1 == 3)
  {
    shift(0x08, 3); 
  }
  if(hr_1 == 4)
  {
    shift(0x08, 4); 
  }
  if(hr_1== 5)
  {
    shift(0x08, 5); 
  }
  if(hr_1 == 6)
  {
    shift(0x08, 6); 
  }
  if(hr_1 == 7)
  {
    shift(0x08, 7); 
  }
  if(hr_1 == 8)
  {
    shift(0x08, 8); 
  }
  if(hr_1 == 9)
  {
    shift(0x08, 9); 
  }/////////////////////////////////////end of first digit for hour  
  

  if(hr_2 == 0)
  {
    shift(0x07, 0); 
  }
  if(hr_2== 1)
  {
    shift(0x07, 1); 
  }
  if(hr_2 == 2)
  {
    shift(0x07, 2); 
  }
  if(hr_2 == 3)
  {
    shift(0x07, 3); 
  }
  if(hr_2 == 4)
  {
    shift(0x07, 4); 
  }
  if(hr_2 == 5)
  {
    shift(0x07, 5); 
  }
  if(hr_2 == 6)
  {
    shift(0x07, 6); 
  }
  if(hr_2 == 7)
  {
    shift(0x07, 7); 
  }
  if(hr_2 == 8)
  {
    shift(0x07, 8); 
  }
  if(hr_2 == 9)
  {
    shift(0x07, 9); 
  }/////////////////////////////////////end of second digit for hour
    

  if(min_1 == 0)
  {
    shift(0x05, 0); 
  }
  if(min_1 == 1)
  {
    shift(0x05, 1); 
  }
  if(min_1 == 2)
  {
    shift(0x05, 2); 
  }
  if(min_1 == 3)
  {
    shift(0x05, 3); 
  }
  if(min_1 == 4)
  {
    shift(0x05, 4); 
  }
  if(min_1== 5)
  {
    shift(0x05, 5); 
  }
  if(min_1 == 6)
  {
    shift(0x05, 6); 
  }
  if(min_1 == 7)
  {
    shift(0x05, 7); 
  }
  if(min_1 == 8)
  {
    shift(0x05, 8); 
  }
  if(min_1 == 9)
  {
    shift(0x05, 9); 
  }/////////////////////////////////////end of first digit for minute
  

  if(min_2 == 0)
  {
    shift(0x04, 0); 
  }
  if(min_2== 1)
  {
    shift(0x04, 1); 
  }
  if(min_2 == 2)
  {
    shift(0x04, 2); 
  }
  if(min_2 == 3)
  {
    shift(0x04, 3); 
  }
  if(min_2 == 4)
  {
    shift(0x04, 4); 
  }
  if(min_2 == 5)
  {
    shift(0x04, 5); 
  }
  if(min_2 == 6)
  {
    shift(0x04, 6); 
  }
  if(min_2 == 7)
  {
    shift(0x04, 7); 
  }
  if(min_2 == 8)
  {
    shift(0x04, 8); 
  }
  if(min_2 == 9)
  {
    shift(0x04, 9); 
  }/////////////////////////////////////end of second digit for minute

 if(sec_1 == 0)
  {
    shift(0x02, 0); 
  }
  if(sec_1 == 1)
  {
    shift(0x02, 1); 
  }
  if(sec_1 == 2)
  {
    shift(0x02, 2); 
  }
  if(sec_1 == 3)
  {
    shift(0x02, 3); 
  }
  if(sec_1 == 4)
  {
    shift(0x02, 4); 
  }
  if(sec_1== 5)
  {
    shift(0x02, 5); 
  }
  if(sec_1 == 6)
  {
    shift(0x02, 6); 
  }
  if(sec_1 == 7)
  {
    shift(0x02, 7); 
  }
  if(sec_1 == 8)
  {
    shift(0x02, 8); 
  }
  if(sec_1 == 9)
  {
    shift(0x02, 9); 
  }/////////////////////////////////////end of first digit for second
  

  if(sec_2 == 0)
  {
    shift(0x01, 0); 
  }
  if(sec_2== 1)
  {
    shift(0x01, 1); 
  }
  if(sec_2 == 2)
  {
    shift(0x01, 2); 
  }
  if(sec_2 == 3)
  {
    shift(0x01, 3); 
  }
  if(sec_2 == 4)
  {
    shift(0x01, 4); 
  }
  if(sec_2 == 5)
  {
    shift(0x01, 5); 
  }
  if(sec_2 == 6)
  {
    shift(0x01, 6); 
  }
  if(sec_2 == 7)
  {
    shift(0x01, 7); 
  }
  if(sec_2 == 8)
  {
    shift(0x01, 8); 
  }
  if(sec_2 == 9)
  {
    shift(0x01, 9); 
  }/////////////////////////////////////end of Second digit for second


  
}


//This function will shift the date to the MAX7219 driver
void print_date_to_7_seg(String the_date)
{

  if(yr_1 == 0)
  {
    shift(0x02, 0); 
  }
  if(yr_1 == 1)
  {
    shift(0x02, 1); 
  }
  if(yr_1 == 2)
  {
    shift(0x02, 2); 
  }
  if(yr_1 == 3)
  {
    shift(0x02, 3); 
  }
  if(yr_1 == 4)
  {
    shift(0x02, 4); 
  }
  if(yr_1== 5)
  {
    shift(0x02, 5); 
  }
  if(yr_1 == 6)
  {
    shift(0x02, 6); 
  }
  if(yr_1 == 7)
  {
    shift(0x02, 7); 
  }
  if(yr_1 == 8)
  {
    shift(0x02, 8); 
  }
  if(yr_1 == 9)
  {
    shift(0x02, 9); 
  }/////////////////////////////////////end of first digit for year
  

  if(yr_2 == 0)
  {
    shift(0x01, 0); 
  }
  if(yr_2== 1)
  {
    shift(0x01, 1); 
  }
  if(yr_2 == 2)
  {
    shift(0x01, 2); 
  }
  if(yr_2 == 3)
  {
    shift(0x01, 3); 
  }
  if(yr_2 == 4)
  {
    shift(0x01, 4); 
  }
  if(yr_2 == 5)
  {
    shift(0x01, 5); 
  }
  if(yr_2 == 6)
  {
    shift(0x01, 6); 
  }
  if(yr_2 == 7)
  {
    shift(0x01, 7); 
  }
  if(yr_2 == 8)
  {
    shift(0x01, 8); 
  }
  if(yr_2 == 9)
  {
    shift(0x01, 9); 
  }/////////////////////////////////////end of second digit for year
    

  if(mon_1 == 0)
  {
    shift(0x05, 0); 
  }
  if(mon_1 == 1)
  {
    shift(0x05, 1); 
  }
  if(mon_1 == 2)
  {
    shift(0x05, 2); 
  }
  if(mon_1 == 3)
  {
    shift(0x05, 3); 
  }
  if(mon_1 == 4)
  {
    shift(0x05, 4); 
  }
  if(mon_1== 5)
  {
    shift(0x05, 5); 
  }
  if(mon_1 == 6)
  {
    shift(0x05, 6); 
  }
  if(mon_1 == 7)
  {
    shift(0x05, 7); 
  }
  if(mon_1 == 8)
  {
    shift(0x05, 8); 
  }
  if(mon_1 == 9)
  {
    shift(0x05, 9); 
  }/////////////////////////////////////end of first digit for month
  

  if(mon_2 == 0)
  {
    shift(0x04, 0); 
  }
  if(mon_2== 1)
  {
    shift(0x04, 1); 
  }
  if(mon_2 == 2)
  {
    shift(0x04, 2); 
  }
  if(mon_2 == 3)
  {
    shift(0x04, 3); 
  }
  if(mon_2 == 4)
  {
    shift(0x04, 4); 
  }
  if(mon_2 == 5)
  {
    shift(0x04, 5); 
  }
  if(mon_2 == 6)
  {
    shift(0x04, 6); 
  }
  if(mon_2 == 7)
  {
    shift(0x04, 7); 
  }
  if(mon_2 == 8)
  {
    shift(0x04, 8); 
  }
  if(mon_2 == 9)
  {
    shift(0x04, 9); 
  }/////////////////////////////////////end of second digit for month
 if(day_1 == 0)
  {
    shift(0x08, 0); 
  }
  if(day_1 == 1)
  {
    shift(0x08, 1); 
  }
  if(day_1 == 2)
  {
    shift(0x08, 2); 
  }
  if(day_1 == 3)
  {
    shift(0x08, 3); 
  }
  if(day_1 == 4)
  {
    shift(0x08, 4); 
  }
  if(day_1== 5)
  {
    shift(0x08, 5); 
  }
  if(day_1 == 6)
  {
    shift(0x08, 6); 
  }
  if(day_1 == 7)
  {
    shift(0x08, 7); 
  }
  if(day_1 == 8)
  {
    shift(0x08, 8); 
  }
  if(day_1 == 9)
  {
    shift(0x08, 9); 
  }/////////////////////////////////////end of first digit for date
  

  if(day_2 == 0)
  {
    shift(0x07, 0); 
  }
  if(day_2== 1)
  {
    shift(0x07, 1); 
  }
  if(day_2 == 2)
  {
    shift(0x07, 2); 
  }
  if(day_2 == 3)
  {
    shift(0x07, 3); 
  }
  if(day_2 == 4)
  {
    shift(0x07, 4); 
  }
  if(day_2 == 5)
  {
    shift(0x07, 5); 
  }
  if(day_2 == 6)
  {
    shift(0x07, 6); 
  }
  if(day_2 == 7)
  {
    shift(0x07, 7); 
  }
  if(day_2 == 8)
  {
    shift(0x07, 8); 
  }
  if(day_2 == 9)
  {
    shift(0x07, 9); 
  }/////////////////////////////////////end of Second digit for date


  
}
